/*
 *
 *   Copyright (c) International Business Machines  Corp., 2000
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *   Module: ldm_dpc.h
 *
 */

#ifndef EVMS_LDM_DPC_H_INCLUDED
#define EVMS_LDM_DPC_H_INCLUDED 1

#include <plugin.h>

#define LDM_PLUGIN_ID_1 SetPluginID(EVMS_OEM_IBM, EVMS_DEVICE_MANAGER, 1)
#define LDM_PLUGIN_ID_2 SetPluginID(EVMS_OEM_IBM, EVMS_DEVICE_MANAGER, 2)
#define LDM_PLUGIN_ID_3 SetPluginID(EVMS_OEM_IBM, EVMS_DEVICE_MANAGER, 3)

/* Interface definition for local disk manager's direct plug-in communication */

#define LDM_GET_DISK_HANDLE 1
typedef struct ld_get_disk_handle_s {
	evms_dev_handle_t kernel_disk_handle;
} ld_get_disk_handle_t;


#define START_CACHE      2

/* START_CACHE has no additional parameters. */
/* The cache is started by default when the Local Disk Manager loads. */


#define STOP_CACHE       3

/* STOP_CACHE has no additional parameters. */


typedef struct ldm_dpc_s {
	u_int32_t   function;
	union {
		ld_get_disk_handle_t get_disk_handle;
	} data;
} ldm_dpc_t;


/* Close any open file descriptors being used to access the specified disk */ 
#define LDM_CLOSE_DISK 5

/* Open and save a file descriptor for accessing the specified disk */
#define LDM_OPEN_DISK  6


#endif

